
#Hi George,

#Here is the code for PyMandel.py... the simple Mandelbrot
#generator in python.  If you don't have psyco installed, you can
#comment out those lines.  Psyco is recommended, though, because it
#does speed up the execution time.  Uncommenting the "extra"
#glColor and glVertex lines makes for some pretty pictures!  I know
#inverse iteration would draw the outline much faster, but would it
#be as colorful?
#----------------------------------------------------------

#PyMandel
#By Stan Blank, Wayne City HS, Illinois, 5mar05

from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
from math import *
import sys

#import psyco
#psyco.full()

def init():
 glClearColor(0.0, 0.0, 0.0, 0.0)  #Black background
 glColor3f(1.0, 0.0, 0.5)
 glOrtho(-2.0,1.0,-1.5,1.5,-1.5,1.5)

def drawMandel():
 glClear(GL_COLOR_BUFFER_BIT)
 glBegin(GL_POINTS)

 y = 1.5
 while y > -1.5:
  y-=.00375
  x = -2.0
  while x < 1.0:
   x+=.00375

   a = x
   b = y
   n = 0

   while n < 100:
    n+=1
    xx = a*a - b*b + x
    yy = 2*a*b + y
    zz = xx*xx + yy*yy

    if zz > 4:
     #glColor3f(sin(zz), sin(zz)*cos(zz), cos(zz))
     glVertex3f(x,y,0)
     n = 5001

    a = xx
    b = yy
   #glColor3f(cos(5*zz),sin(4*zz)*cos(4*zz),sin(2*zz))
   #glVertex3f(x,y,0)
 glEnd()
 glFlush()

def main():
 glutInitDisplayMode(GLUT_RGB | GLUT_SINGLE)
 glutInitWindowPosition(50, 50)
 glutInitWindowSize(800, 800)
 glutInit(sys.argv)
 glutCreateWindow("Mandelbrot")
 glutDisplayFunc(drawMandel)
 init()
 glutMainLoop()

main()

